﻿package com.nacookan.calculator 
{
	import flash.display.*;
	import flash.events.*;
	import flash.text.*;
	import caurina.transitions.Tweener;
	
	/**
	 * ...
	 * @author nacookan
	 */
	public class Button extends SimpleButton
	{
		public var text:String;
		
		public function Button(width:Number, height:Number, text:String):void {
			this.text = text;
			upState = generateImage(0x55ddff, width, height, text);
			overState = generateImage(0x77eeff, width, height, text);
			downState = generateImage(0x33aaff, width, height, text);
			useHandCursor = true;
			hitTestState = upState;
			
			alpha = 0;
			z = -100;
			rotation = 20;
			Tweener.addTween(this, {
				alpha: 1,
				z: 0,
				rotation: 0,
				time: 1,
				transition: 'easeInExpo'
			});
		}
		
		private function generateImage(color:Number, width:Number, height:Number, text:String):Sprite {
			var sp:Sprite = new Sprite();
			sp.graphics.lineStyle(2, 0x555555);
			sp.graphics.beginFill(color);
			sp.graphics.drawRoundRect(0, 0, width, height, 5, 5);
			sp.graphics.endFill();
			
			var f:TextFormat = new TextFormat();
			f.font = '_sans';
			f.color = 0x5333333;
			f.size = 21;
			var t:TextField = new TextField();
			t.defaultTextFormat = f;
			t.text = text;
			t.autoSize = TextFieldAutoSize.LEFT;
			t.mouseEnabled = false;
			t.x = (sp.width - t.width) / 2;
			t.y = (sp.height - t.height) / 2;
			sp.addChild(t);
			
			var inframe:Sprite = new Sprite();
			inframe.addChild(sp);
			sp.x = 0 - width / 2;
			sp.y = 0 - height / 2;
			
			var outframe:Sprite = new Sprite();
			outframe.addChild(inframe);
			inframe.x = width / 2;
			inframe.y = height / 2;
			
			addEventListener(MouseEvent.MOUSE_DOWN, function(e:MouseEvent):void {
				inframe.rotationY = 0;
				Tweener.addTween(inframe, {
					rotationY: 360,
					time: 0.5,
					transition: 'easeOutElastic'
				});
			});
			
			addEventListener(MouseEvent.ROLL_OVER, function(e:MouseEvent):void {
				Tweener.addTween(inframe, {
					z: -12,
					time: 0.5,
					transition: 'easeOutElastic'
				});
			});
			
			addEventListener(MouseEvent.ROLL_OUT, function(e:MouseEvent):void {
				Tweener.addTween(inframe, {
					z: 0,
					time: 1,
					transition: 'easeOutElastic'
				});
			});
			
			return outframe;
		}
	}
}