﻿package com.nacookan.calculator
{
	import flash.display.*;
	import flash.events.*;
	import flash.text.*;
	import flash.desktop.NativeApplication;
	import jp.progression.commands.*;
	
	/**
	 * ...
	 * @author nacookan
	 */
	public class Main extends Sprite 
	{
		private var monitor:Monitor;
		private var buffer:Number = 0;
		private var newDigit:Boolean = true;
		
		public function Main():void {
			makeForm();
			monitor.digit = 0;
		}
		
		private function makeForm():void {
			var functions:Array = [
				new Func(function():void { monitor = makeMonitor(10, 10); }),
				new Func(makeButton, ['C', 10, 100, clearButton_handler, true]),
				new Func(makeButton, ['Back', 130, 100, backButton_handler, true]),
				new Func(makeButton, ['÷', 190, 160, divideButton_handler, false]),
				new Func(makeButton, ['9', 130, 160, numberButton_handler, false]),
				new Func(makeButton, ['8', 70, 160, numberButton_handler, false]),
				new Func(makeButton, ['7', 10, 160, numberButton_handler, false]),
				new Func(makeButton, ['4', 10, 220, numberButton_handler, false]),
				new Func(makeButton, ['5', 70, 220, numberButton_handler, false]),
				new Func(makeButton, ['6', 130, 220, numberButton_handler, false]),
				new Func(makeButton, ['×', 190, 220, timesButton_handler, false]),
				new Func(makeButton, ['-', 190, 280, minusButton_handler, false]),
				new Func(makeButton, ['3', 130, 280, numberButton_handler, false]),
				new Func(makeButton, ['2', 70, 280, numberButton_handler, false]),
				new Func(makeButton, ['1', 10, 280, numberButton_handler, false]),
				new Func(makeButton, ['0', 10, 340, numberButton_handler, false]),
				new Func(makeButton, ['=', 70, 340, equalButton_handler, true]),
				new Func(makeButton, ['+', 190, 340, plusButton_handler, false])
			];
			var list:SerialList = new SerialList();
			for (var i:Number = 0; i < functions.length; i++) {
				list.addCommand(functions[i]);
				list.addCommand(new Wait(50));
			}
			list.execute();
		}
		
		private function makeButton(text:String, x:Number, y:Number, handler:Function, wideSize:Boolean):Button {
			var width:Number = wideSize ? 110 : 50;
			var b:Button = new Button(width, 50, text);
			b.x = x;
			b.y = y;
			b.addEventListener(MouseEvent.MOUSE_DOWN, handler);
			addChild(b);
			return b;
		}
		
		private function makeMonitor(x:Number, y:Number):Monitor {
			var m:Monitor = new Monitor(230, 80);
			m.x = 10;
			m.y = 10;
			addChild(m);
			return m;
		}
		
		private function calc():void {
			switch(monitor.sign) {
				case '+': buffer += monitor.digit; break;
				case '-': buffer -= monitor.digit; break;
				case '×': buffer *= monitor.digit; break;
				case '÷': buffer /= monitor.digit; break;
				default: buffer = monitor.digit; break;
			}
			monitor.digit = buffer;
		}
		
		private function setSign(sign:String):void {
			if(!newDigit) calc();
			monitor.sign = sign;
			newDigit = true;
		}
		
		private function numberButton_handler(e:MouseEvent):void {
			var current:String = monitor.digit.toString();
			if (10 <= current.length) return;
			
			if (newDigit) {
				current = '';
				newDigit = false;
			}
			
			var b:Button = e.target as Button;
			monitor.digit = parseInt(current + b.text, 10);
		}
		
		private function equalButton_handler(e:MouseEvent):void {
			setSign('');
			monitor.highlight();
		}
		
		private function plusButton_handler(e:MouseEvent):void {
			setSign('+');
		}
		
		private function minusButton_handler(e:MouseEvent):void {
			setSign('-');
		}
		
		private function timesButton_handler(e:MouseEvent):void {
			setSign('×');
		}
		
		private function divideButton_handler(e:MouseEvent):void {
			setSign('÷');
		}
		
		private function clearButton_handler(e:MouseEvent):void {
			monitor.digit = 0;
			buffer = 0;
			setSign('');
			monitor.highlight_digit();
		}
		
		private function backButton_handler(e:MouseEvent):void {
			monitor.highlight_digit();
			var current:String = monitor.digit.toString();
			if (current == '0') return;
			if (current.length == 1) {
				monitor.digit = 0;
				return;
			}
			monitor.digit = parseInt(current.substr(0, current.length - 1), 10);
		}
	}
}