﻿package com.nacookan.calculator 
{
	import flash.display.*;
	import flash.text.*;
	import caurina.transitions.Tweener;
	
	/**
	 * ...
	 * @author nacookan
	 */
	public class Monitor extends Sprite
	{
		private var digit_txt:TextField;
		private var sign_txt:TextField;
		private var _digit:Number = 0;
		private var _sign:String = '';
		
		public function Monitor(width:Number, height:Number) {
			var frame_sp:Sprite = new Sprite();
			frame_sp.graphics.lineStyle(2, 0x555555);
			frame_sp.graphics.beginFill(0xeaeaea);
			frame_sp.graphics.drawRoundRect(0, 0, width, height, 5, 5);
			frame_sp.graphics.endFill();
			
			var digit_tf:TextFormat = new TextFormat();
			digit_tf.font = '_sans';
			digit_tf.color = 0x3333333;
			digit_tf.size = 40;
			digit_txt = new TextField();
			digit_txt.defaultTextFormat = digit_tf;
			digit_txt.autoSize = TextFieldAutoSize.RIGHT;
			digit_txt.mouseEnabled = false;
			digit_txt.text = '-';
			digit_txt.x = frame_sp.width - 20;
			digit_txt.y = (frame_sp.height - digit_txt.height) / 2;
			frame_sp.addChild(digit_txt);
			
			var sign_tf:TextFormat = new TextFormat();
			sign_tf.font = '_sans';
			sign_tf.color = 0x333333;
			sign_tf.size = 20;
			sign_txt = new TextField();
			sign_txt.defaultTextFormat = sign_tf;
			sign_txt.autoSize = TextFieldAutoSize.CENTER;
			sign_txt.mouseEnabled = false;
			sign_txt.text = '';
			sign_txt.x = frame_sp.width - 15;
			sign_txt.y = 2;
			frame_sp.addChild(sign_txt);
			
			addChild(frame_sp);
			
			alpha = 0;
			z = -100;
			rotation = 20;
			Tweener.addTween(this, {
				alpha: 1,
				z: 0,
				rotation: 0,
				time: 1,
				transition: 'easeInQuart'
			});
		}
		
		public function set digit(value:Number):void {
			_digit = value;
			reload();
		}
		
		public function get digit():Number {
			return _digit;
		}
		
		public function set sign(value:String):void {
			_sign = value;
			reload();
			
			var goal_y:Number = sign_txt.y;
			sign_txt.y = -10;
			Tweener.addTween(sign_txt, {
				y: 2,
				time: 1,
				transition: 'easeOutElastic'
			});
		}
		
		public function get sign():String {
			return _sign;
		}
		
		public function highlight():void {
			z = -20;
			Tweener.addTween(this, {
				z: 0,
				time: 1,
				transition: 'easeOutElastic'
			});
		}
		
		public function highlight_digit():void {
			digit_txt.y = 0;
			Tweener.addTween(digit_txt, {
				y: (height - digit_txt.height) / 2,
				time: 1,
				transition: 'easeOutElastic'
			});
		}
		
		private function reload():void {
			digit_txt.text = _digit.toString();
			sign_txt.text = _sign;
		}
	}
}